package eu.ruekov.ruakij.LinkedBeaconTeleporters.listener;

import eu.ruekov.ruakij.LinkedBeaconTeleporters.Function;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.Main;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.customPlayerMoveEvent.CustomPlayerMoveEvent;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.customPlayerMoveEvent.CustomPlayerMoveEventListener;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.linkedBeaconTeleporter.LinkedBeaconTeleporter;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.linkedBeaconTeleporter.LinkedBeaconTeleporterBlock;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.util.Vector;

import java.util.HashMap;
import java.util.List;
import java.util.UUID;

public class OnCustomPlayerMove implements CustomPlayerMoveEventListener {

    static HashMap<UUID, LinkedBeaconTeleporterBlock> playerBeaconLocation = new HashMap<>();

    @Override
    public void tick(CustomPlayerMoveEvent e) {
    }

    @Override
    public void locationChange(CustomPlayerMoveEvent e) {

        Player p = e.player();
        UUID uuid = p.getUniqueId();

        // If player found in ignoreList, remove
        if(playerBeaconLocation.containsKey(uuid))
            playerBeaconLocation.remove(uuid);

        // Check if player is on-top of a beacon
        Block block = Function.searchForMaterial(
                p.getLocation().add(0, -1, 0),
                new Vector(0, -1, 0),
                Material.BEACON,
                Function.transparentMaterials
        );

        // Skip if not found
        if(block == null) return;

        // TODO: Check if beacon is active

        // Check if beacon is a LinkedBeaconTeleporter
        LinkedBeaconTeleporterBlock lbtBlock = Main.lbtManager.getLbtBlockFromLocation(block.getLocation());

        // Ignore if not found
        if(lbtBlock == null) return;

        // Check if player should be ignored on this LinkedBeaconTeleporter
        // FIXME: Will remove player from list, even though he should be ignored :/
        if(playerBeaconLocation.get(uuid) != null && playerBeaconLocation.get(uuid) == lbtBlock) return;

        // Get first partner thats not our current-block
        LinkedBeaconTeleporterBlock lbtBlockPartner = null;
        for(LinkedBeaconTeleporter lbtBlockTmp: lbtBlock.linkedBeaconTeleporters()){
            // Upcast as linked-Teleporters are only blocks anyways
            if((LinkedBeaconTeleporterBlock)lbtBlockTmp != lbtBlock){
                lbtBlockPartner = (LinkedBeaconTeleporterBlock)lbtBlockTmp;
                break;
            }
        }
        if(lbtBlockPartner == null){
            // No other partner
        }
        else{
            // Set player as ignored on target-LinkedBeaconTeleporter (so he wont trigger the teleport again)
            playerBeaconLocation.put(uuid, lbtBlockPartner);

            // Teleport
            e.player().teleport(
                    lbtBlockPartner.block().getLocation().add(0.5, 1, 0.5)
            );
        }
    }
}
